.model small
.stack 100h
.data

  about        db "Programa, suskaidanti faila i nurodyto dydzio gabaliukus (paskutinis ju gali buti mazesnis).", 10, 13, "Pvz.: suskaidytu faila file.txt i 500 baitu dydzio failiukus file.01, file.02 ir t.t.", 10, 13, '$'
  instructions db "Komandos sintakse:", 10, 13, "       programa    duom_failas.txt    po_kiek_baitu    rezult_failas", 10, 13, '$'
  example      db "PVZ.:  v2    failas.txt    500    rez", 10, 13, '$'
 
; failu pavadinimai
  data         db 100 dup(0)
  bytes        db 100 dup('$')
  result       db 100 dup(0)
  
  bytes_hex    dw ?
  total        dw ?
  saved        dw ?
 
; klaidos
  error_msg_1  db "Klaida: nepavyko atidaryti duomenu failo", 10, 13, '$'
  error_msg_2  db "Klaida: nepavyko nuskaityti duomenu failo", 10, 13, '$'
  error_msg_3  db "Klaida: nepavyko sukurti rezultato failo", 10, 13, '$'
  error_msg_4  db "Klaida: nepavyko irasyti duomenu i rezultato faila", 10, 13, '$'
  error_msg_5  db "Klaida: nepavyko uzdaryti duomenu failo", 10, 13, '$'
  error_msg_6  db "Klaida: nepavyko uzdaryti rezultato failo", 10, 13, '$'

; failu handlai
  handle_in    dw ?
  handle_out   dw ?
    
  buffer       db 20 dup(0)  ; nuskaitymo bufferis
  bytes_left   dw ?
  bytes_right  dw ?

.code
begin:
  mov    ax, @data
  mov    ds, ax
  mov    saved, 0
  
;--------------------- Nuskaitom parametrus
  mov    bx, 82h
  xor    cx, cx ; parametru sk.
check:
  mov    ax, es:[bx]
  inc    bx
  
  cmp    al, 13
  je     controller
  cmp    al, ' '
  je     check
  cmp    ax, "?/"
  je     help
  
  cmp    cx, 0000h
  je     name_data
  cmp    cx, 0001h
  je     bytes_amount
  cmp    cx, 0002h
  je     name_result
  
  jmp     controller
  name_data:
    mov    [offset data + si], al
    inc    si
	cmp    ah, ' '
	je     count_parameters
    jmp    check
  bytes_amount:
    mov    [offset bytes + si], al
    inc    si
	cmp    ah, ' '
	je     count_parameters
    jmp    check
  name_result:
    mov    [offset result + si], al
    inc    si
	mov    di, si
	cmp    ah, ' '
	je     count_parameters
	cmp    ah, 10
	je     count_parameters
    jmp    check
count_parameters:
  inc    cx
  xor    si, si
  jmp    check
  
controller:
  cmp    cx, 0002h
  je     check_files
  jmp    help
  
help:
  mov    dx, offset about
  mov    ah, 09h
  int    21h
  mov    dx, offset instructions
  mov    ah, 09h
  int    21h
  mov    dx, offset example
  mov    ah, 09h
  int    21h
  
  jmp    exit

;--------------------- Atidarom duomenu faila
check_files:
  xor    ax, ax ; cia rinksim sskaiciu
  mov    bx, 0Ah   ; dauginam is 10
  xor    si, si ; kuri baita nuskaitinejam
part_size:
  xor    cx, cx
  mul    bx
  mov    dx, offset [bytes + si]
  inc    si
  mov    cl, dl
  sub    cl, 30h
  add    ax, cx
  cmp    dh, '$' ; jei sekantis pabaigos zenklas
  jne    part_size
  mov    bytes_hex, ax ; issaugom

  mov    dx, offset data
  mov    al, 0         ; atidarom readinimui
  mov    ah, 3Dh
  int    21h
  jc     error_1_trp            ; klaida atidarant duomenu faila
  mov    handle_in, ax
  
  xor    cx, cx
  xor    dx, dx
  mov    bx, handle_in
  mov    al, 02h
  mov    ah, 42h
  int    21h
  mov    total, ax  ; suskaiciuojam kiek viso simboliu
  
  xor    cx, cx
  xor    dx, dx
  mov    bx, handle_in
  mov    al, 00h               ; nustatom zymekli i failo prieki
  mov    ah, 42h
  int    21h
  
  xor    cx, cx
  xor    dx, dx
  mov    bx, handle_in
  mov    al, 01h
  mov    ah, 42h
  int    21h
  
  jmp    pre_read
  
;--------------------- Tarpiniai jumpai
error_1_trp:
  jmp error_1

;--------------------- Readinam duomenu faila
pre_read:
  mov    cx, 0      ; kelintas rezultatu failas?
  push   cx
  mov    cx, 0      ; kiek nuskaityta baitu vienam rezultatu failui?
  push   cx

read:
  mov    bytes_left, 0
  
  mov    cx, 20            ; kiek baitu nuskaitysim (bufferio dydis)?
  mov    dx, offset buffer
  mov    bx, handle_in
  mov    ah, 3Fh
  int    21h
  
  cmp    ax, 0
  je     exit_trp      ; baigesi duomenu failas
  
  mov    si, ax    ; issaugom kiek baitu buvo nuskaityta paskutini karta
  pop    cx
  cmp    cx, 0
  je     new_file
  mov    dx, cx
  add    dx, si
  cmp    dx, bytes_hex
  jna    usual 

  mov    dx, bytes_hex
  sub    dx, cx
  mov    bytes_left, dx
  neg    dx
  add    dx, si
  mov    bytes_right, dx
  
  mov    cx, bytes_left    ; kiek baitu irasis?
  mov    dx, offset buffer
  mov    bx, handle_out
  mov    ah, 40h
  int    21h
  ;jc     error_4
  
  mov    si, bytes_right
  jmp    new_file
;--------------------- Tarpiniai jumpai
exit_trp:
  jmp    exit
read_trp:
  jmp    read
;--------------------- Issaugom rezultatus
usual:
  add    cx, si
  push   cx
  add    saved, si
  
  mov    cx, si           ; kiek baitu irasis?
  mov    dx, offset buffer
  mov    bx, handle_out
  mov    ah, 40h
  int    21h
;  jc     error_4
  
  jmp    finish_check
new_file:
  pop    ax
  inc    ax
  push   ax
  
  add    ax, 30h
  mov    ah, '.'
  mov    [offset result + di], ah ; tasko hex kodas
  mov    [offset result + di + 1], al
    
  mov    cx, 0         ; nustatom baitu counteri is naujo
  add    cx, si
  push   cx
  add    saved, si

  mov    dx, offset [result]
  xor    cx, cx            
  mov    ah, 3Ch                  ; sukuriam rezultato faila
  int    21h
  jc     error_3
  mov    handle_out, ax
  
  xor    cx, cx
  xor    dx, dx
  mov    bx, handle_out
  mov    al, 01h
  mov    ah, 42h
  int    21h
 
  mov    cx, si           ; kiek baitu irasis?
  mov    si, bytes_left
  mov    dx, offset [buffer]
  add    dx, si
  mov    bx, handle_out
  mov    ah, 40h
  int    21h
  jc     error_4

;--------------------- Tikrinam ar baigesi duomenys
finish_check:
  mov    ax, total
  cmp    ax, saved
  ja     read_trp
  jmp    exit
;----------- Uzdarom duomenu faila
close:
  mov    ah, 3Eh
  mov    bx, handle_in
  int    21h        
  jc     error_4            ; klaida uzdarant duomenu faila

  jmp    exit
;--------------------- Klaidos
error_1:
  lea    dx, error_msg_1
  mov    ah, 09h
  int    21h
  jmp    exit
error_2:
  lea    dx, error_msg_2
  mov    ah, 09h
  int    21h
  jmp    exit
error_3:
  lea    dx, error_msg_3
  mov    ah, 09h
  int    21h
  jmp    exit
error_4:
  lea    dx, error_msg_4
  mov    ah, 09h
  int    21h
  jmp    exit
error_5:
  lea    dx, error_msg_5
  mov    ah, 09h
  int    21h
  jmp    exit
error_6:
  lea    dx, error_msg_5
  mov    ah, 09h
  int    21h
  jmp    exit
;--------------------- Programos pabaiga
exit:
  mov    ah, 4Ch
  int    21h

end begin